      PROGRAM CASMAIN
      Implicit None
c	Integer N1,N2
	Integer K1,K2,LUX
#include "casluco.inc"
#include "casparas.inc"
#include "casvalues.inc"
#include "caseffic.inc"
#include "caslujets.inc"

      Integer j
      real pta0, eta0, dna0, ptam, ptrms, etam, etrms, dnam, dnrms
      real ptrm0, etrm0, dnrm0
      real av, etas, pts, cost, eta, pt 
      real sec0, secrm0, sec, secrms
      real val, errval 
      
      Integer IGLU
	Common/CAGLUON/Iglu

      Integer ISEED,I
	
	Integer Nevent
	Common/steer1/Nevent
	
      Integer IVEC(25)
      Integer Irr	
	real timeleft
	Integer Minuts
	External Minuts
      External Pydata

	Logical ex
	
      call dummysub(pydata)
      
      ISEED = Iabs(MINUTS())
c	ISEED = 47034466
C initialize random number generator	
c      n1=0
c      n2=0
c      CALL RM48IN(ISEED,N1,N2)
c      LUX = 3
      LUX = 4
      K1=0
      K2=0
      CALL RLUXGO(LUX,ISEED,K1,K2)
C initialise PYTHIA 6 parameters, now done via block data
C initialise CASCADE parameters
      CALL CASINI

      CALL STEER
	
C-- change standard parameters of CASCADE
	Call cascha
c
C-- change standard parameters of JETSET/PYTHIA
      Call pytcha
	inquire(FILE='pythia64-update-particle.dat',EXIST=ex)
       if(ex) then
         open(3,FILE='pythia64-update-particle.dat', FORM='formatted',
     +    STATUS='OLD',IOSTAT=IRR,ERR=220)
         write(6,*) ' updating PYTHIA particle data with file ',
     +    'pythia64-update-particle.dat'
	   call pyupda(3,3)
      else 
         write(6,*) '  PYTHIA particle data file not existing ' 
         open(3,FILE='pythia64-test.dat', FORM='formatted',STATUS='NEW',
     +   IOSTAT=IRR,ERR=220)
	   call pyupda(1,3)
         write(6,*) ' pythia64-test.dat written '
         write(6,*) ' NOTE: since no update of file ',
     +    'no 2 or 3S resonances can be produced'
	Endif
      close(3)
      
c      call PYLIST(12)
c
c Start integration of x-section
c

      CALL CASCADE
c
c Print out result of integration of x-section
c
      CALL CAEND(1)
	
c
c Start event loop
* set original (rounded) test values and its rms for current model parameters
      sec0   = 396495.8
      secrm0 = 1691.4   
      pta0=  0.4189 
      ptrm0=0
      eta0= 12.28
      etrm0=0
      dna0= 156.901
      dnrm0=0
* set initial test values and its rms
      ptam=0. 
      ptrms=0. 
      etam=0. 
      etrms=0.       
      dnam=0.  
      dnrms=0.       
c
c	pause
      Do I=1,max(10,Nevent)

c	   call timel(timeleft)
c         CALL RLUXUT(IVEC)
c         write(45,*) ' ivec = ',ivec
c         write(45,*) ' time left ',timeleft
c         rewind(45)
c         if(timeleft.le.300.) goto 123
c generate an event
         CALL EVENT
c	   write(6,*) ' after event ',I

        if(N.le.0) write(6,*) "N=0  !!!!!"
        av = 0.
        etas = 0.
        pts = 0.
        if(N.gt.0) then
            do j=1,N
            if(K(j,1).eq.1) then
               av = av + 1.
               cost = P(j,3) / sqrt(P(j,1)**2 + P(j,2)**2 + P(j,3)**2)
               if(abs(cost).LT.0.999999) then
                  eta = 0.5 * alog((1.+ cost)/(1.- cost))
               else
                 eta=100.
               endif
               etas = etas + abs(eta)
               pt = sqrt(P(j,1)**2+P(j,2)**2)
               pts = pts + pt
            Endif
            Enddo
         Endif
         if (av.gt.0) then
            etas = etas/av
            pts = pts/av
         endif
         etam = etam + etas
         etrms = etrms + (etas-eta0)**2
         ptam = ptam + pts
         ptrms = ptrms + (pts-pta0)**2
         dnam = dnam + av
         dnrms = dnrms + (av-dna0)**2
      Enddo
123   Continue
c
c Print out of generated events summary
c
      CALL CAEND(20)
* test calculating and printing of original "true" (rounded) numbers
* and generated one's (with statistical errors)
      etam=etam/float(Nevent)
      etrms=sqrt(etrms/(float(Nevent)-1.))
      ptam=ptam/float(Nevent)
      ptrms=sqrt(ptrms/(float(Nevent)-1.))
      dnam=dnam/float(Nevent)
      dnrms=sqrt(dnrms/(float(Nevent)-1.))
c
10000 FORMAT('  sigma  = ',f26.1,' nb   +/- ',f26.1)
      sec = AVGI
      secrms = SD
      WRITE(6,10000) sec, secrms
      write(6,1) dna0
1     format(2x,'True mean multiplicity =',f19.10) 
      write(6,2) dnam, dnrms 
2     format(2x,'Generated mean multiplicity      =',f19.10,3x,
     > '+-  ',f19.10) 
      write(6,3) eta0
3     format(2x,'True mean pseudorapidity =',f19.10) 
      write(6,4) etam, etrms 
4     format(2x,'Generated mean pseudorapidity      =',f19.10,3x,
     > '+-  ',f19.10) 
      write(6,5) pta0
5     format(2x,'True mean transverse momentum =',f19.10)  
      write(6,6) ptam, ptrms 
6     format(2x,'Generated mean transverse momentum      =',f19.10,3x,
     > '+-  ',f19.10)  
      	
      STOP
  220 write(6,*) ' error opening  file for PYTHIA update '
      STOP
      END

      subroutine dummysub(a)
      return
      end



